##############################################################################
#
# Copyright (c) 2002 Nik Kim <fafhrd@mindless.com> All Rights Reserved.
# 
# This software is subject to the provisions of the Zope Public License,
# Version 2.0 (ZPL).  A copy of the ZPL should accompany this distribution.
# THIS SOFTWARE IS PROVIDED "AS IS" AND ANY AND ALL EXPRESS OR IMPLIED
# WARRANTIES ARE DISCLAIMED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
# WARRANTIES OF TITLE, MERCHANTABILITY, AGAINST INFRINGEMENT, AND FITNESS
# FOR A PARTICULAR PURPOSE
#
##############################################################################

from Globals import InitializeClass
from AccessControl import ClassSecurityInfo
from Products.CMFCore.CMFCorePermissions import View, ModifyPortalContent
from Products.Formulator import Validator, Widget
from CMFStringField import CMFStringField


factory_type_information = (
    {   'id'             : 'Form EmailField',
        'meta_type'      : 'CMF Form EmailField',
        'description'    : """Form EmailField""",
        'icon'           : 'EmailField.gif',
        'product'        : 'CMFFormulator',
        'factory'        : 'manage_addEmailField',
        'immediate_view' : 'ffield_str_edit_form',
        'actions'        :
      ( { 'id'         : 'view',
          'name'       : 'View',
          'action'     : 'ffield_view',
          'permissions': (View,),
          'category'   : 'object',
          },
        {'id'         : 'edit',
         'name'       : 'Edit',
         'action'     : 'ffield_str_edit_form',
         'permissions': (ModifyPortalContent,),
         'category'   : 'object',
         },
        {'id'         : 'metadata',
         'name'       : 'Metadata',
         'action'     : 'metadata_edit_form',
         'permissions': (ModifyPortalContent, ),
         'category'   : 'object',
          },        
        )
        },
    )


class CMFEmailField(CMFStringField):
    meta_type = 'CMF Form EmailField'

    security = ClassSecurityInfo()

    widget = Widget.TextWidgetInstance
    validator = Validator.EmailValidatorInstance

InitializeClass(CMFEmailField)

def manage_addEmailField(self, id, title="", REQUEST=None, **kwargs):
    """Add form to folder. """
    id = self._setObject(id, CMFEmailField(id, title, **kwargs))
    
    if REQUEST is not None:
        return self.folder_contents( # XXX: ick!
            self, REQUEST, portal_status_message="EmailField form added")

