from Products.CMFCore.TypesTool import FactoryTypeInformation
from Products.CMFCore.DirectoryView import addDirectoryViews
from Products.CMFCore.utils import getToolByName
from Products.CMFFormulator import formulator_globals, factory_type_information

from Acquisition import aq_base
from cStringIO import StringIO
import string

FORMULATOR_SKINS = ('formulator',)

def install(self):
    " Register CMFFormulator types and skins "
    out = StringIO()
    skinstool = getToolByName(self, 'portal_skins')

    for dir_view in FORMULATOR_SKINS:
        if dir_view in skinstool.objectIds():
            skinstool._delObject( dir_view )

    addDirectoryViews( skinstool, 'skins', formulator_globals )
    out.write( "Added CMFFormulator directory views to portal_skins\n" )

    #
    #   Add a new skin, 'ZPT', copying 'Basic', if it exists, and then
    #   add our directories only to it.
    #
    if skinstool.getSkinPath( 'Formulator' ) is None:

	path = skinstool.getSkinPath( skinstool.getDefaultSkin() )
        path = map( string.strip, string.split( path,',' ) )
        for dir in FORMULATOR_SKINS:
            try:
                path.insert( path.index( 'content' ), dir )
            except ValueError:
                path.append( dir )
                    
        path = string.join( path, ', ' )
        skinstool.addSkinSelection( 'Formulator', path )
        out.write( "Added Formulator skin\n" )
    
    else:
        out.write( "Formulator skin already exists\n" )

    # install CMFFormulator Types
    typestool = getToolByName(self, 'portal_types')

    for fti in factory_type_information:
        if fti['id'] not in typestool.objectIds():
            efm = FactoryTypeInformation(**fti)
            typestool._setObject(fti['id'], efm)
    out.write( "Added CMFFormulator Types\n" )

    return out.getvalue()
