##############################################################################
#
# Copyright (c) 2002 Nik Kim <fafhrd@mindless.com> All Rights Reserved.
# 
# This software is subject to the provisions of the Zope Public License,
# Version 2.0 (ZPL).  A copy of the ZPL should accompany this distribution.
# THIS SOFTWARE IS PROVIDED "AS IS" AND ANY AND ALL EXPRESS OR IMPLIED
# WARRANTIES ARE DISCLAIMED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
# WARRANTIES OF TITLE, MERCHANTABILITY, AGAINST INFRINGEMENT, AND FITNESS
# FOR A PARTICULAR PURPOSE
#
##############################################################################

from Products.CMFCore import utils
from Products.CMFCore.DirectoryView import registerDirectory
from Products.CMFCore.CMFCorePermissions import AddPortalContent

from Products.Formulator.FieldRegistry import FieldRegistry
import FSForm, FakeField
FieldRegistry.registerField(FakeField.FakeField, 'www/StringField.gif')
utils.registerIcon(FSForm.FSForm, 'dtml/Form.gif', globals())

import CMFForm, \
       CMFStringField, CMFIntegerField, CMFTextAreaField, \
       CMFEmailField, CMFCheckBoxField, CMFMultiCheckBoxField, \
       CMFRadioField

import MailStorage

contentClasses = (
    CMFForm.CMFForm,
    CMFStringField.CMFStringField,
    CMFEmailField.CMFEmailField,
    CMFIntegerField.CMFIntegerField,
    CMFTextAreaField.CMFTextAreaField,
    CMFCheckBoxField.CMFCheckBoxField,
    CMFMultiCheckBoxField.CMFMultiCheckBoxField,
    CMFRadioField.CMFRadioField,

    MailStorage.MailStorage,
    )

contentConstructors = (
    CMFForm.manage_addFormulatorForm,
    CMFEmailField.manage_addEmailField,
    CMFStringField.manage_addStringField,
    CMFIntegerField.manage_addIntegerField,
    CMFTextAreaField.manage_addTextAreaField,
    CMFCheckBoxField.manage_addCheckBoxField,
    CMFMultiCheckBoxField.manage_addMultiCheckBoxField,
    CMFRadioField.manage_addRadioField,

    MailStorage.manage_addMailStorage,
    )

factory_type_information = (
    CMFForm.factory_type_information +
    CMFEmailField.factory_type_information +
    CMFStringField.factory_type_information +
    CMFTextAreaField.factory_type_information +
    CMFIntegerField.factory_type_information +
    CMFCheckBoxField.factory_type_information +
    CMFMultiCheckBoxField.factory_type_information +
    CMFRadioField.factory_type_information +

    MailStorage.factory_type_information
    )

import sys
this_module = sys.modules[__name__]
formulator_globals = globals()

z_bases = utils.initializeBasesPhase1( contentClasses, this_module )

registerDirectory('skins', globals())

def initialize( context ):

    utils.initializeBasesPhase2( z_bases, context )
    utils.ContentInit( 'CMFFormulator Content', content_types=contentClasses,
                       permission=AddPortalContent,
                       extra_constructors=contentConstructors,
                       fti=factory_type_information
                       ).initialize( context )
